<?php
// Report to forum Plugin for MyBB 1.4x by John Skopa
// Version 1.0

// Tell MyBB when to run the hooks
// $plugins->add_hook("hook name", "function name");
$plugins->add_hook("report_do_report_start", "reporttoforum_run");

// The information that shows up on the plugin manager
// Note that the name of the function before _info, _activate, _deactivate must be the same as the filename before the extension.
function reporttoforum_info() {
	return array(
		"name"			=> "Report Post to a Forum",
		"description"	=> "Places reported posts in a thread in a specified forum just like vBulletin system does.",
		"website"		=> "http://community.mybboard.net/user-13347.html",
		"author"		=> "John_S",
		"authorsite"	=> "http://community.mybboard.net/user-13347.html",
		"version"		=> "1.0",
		"compatibility" => "14*",
	);
}

// This function is called when plugin is installed.
function reporttoforum_activate() {
	global $db;
	
	$query = $db->insert_id($db->query("INSERT INTO ".TABLE_PREFIX."settinggroups (gid,name,title,description,disporder,isdefault) VALUES (NULL ,'reporttoforum','Report to Forum','These options allow you to manage various aspects of the Report to Forum plugin.','0','0');"));
	
	$db->query("INSERT INTO ".TABLE_PREFIX."settings (sid,name,title,description,optionscode,value,disporder,gid,isdefault)
	VALUES (NULL ,'reporttoforum_switch','Active','Controls either yes or no the plugin is activated.','yesno','0','1','$query','0');");
	$db->query("INSERT INTO ".TABLE_PREFIX."settings (sid,name,title,description,optionscode,value,disporder,gid,isdefault)
	VALUES (NULL ,'reporttoforum_forum','Forum','<strong>Forum ID</strong> of the forum where reports will be posted.','text','1','2','$query','0');");
	$db->query("INSERT INTO ".TABLE_PREFIX."settings (sid,name,title,description,optionscode,value,disporder,gid,isdefault) VALUES (NULL, 'reporttoforum_only', 'Only Post on Forum?', 'If set to yes, the reports will only be posted on the forum specified.  If set to no, the other notification options in the General Configuration will be taken into account', 'yesno', '1', '3', $query, '0')");
	
	rebuild_settings();
}

// This is the function that is run when the hook is called.
// It must match the function name you placed when you called add_hook.
// You are not just limited to 1 hook per page. You can add as many as you want.
function reporttoforum_run($post) {
	global $mybb, $db, $post, $thread, $pid, $forum, $templates, $cache;
	
	if(intval($mybb->settings['reporttoforum_forum']) > 0 && $mybb->settings['reporttoforum_switch'] == "1")
	{
		if(!trim($mybb->input['reason']))
		{
			global $lang, $settings, $theme, $plugins, $mybbuser, $mybbgroup, $headerinclude;
			global $querytime, $debug, $templatecache, $templatelist, $maintimer, $globaltime, $parsetime;
			eval("\$report = \"".$templates->get("report_noreason")."\";");
			output_page($report);
			exit;
		}
	
		// Message template
		$forum = $db->fetch_array($db->simple_select("forums", "*", "fid={$post['fid']}"));
		
		$post_subject = $db->escape_string(htmlspecialchars_uni($post['subject']));
		$forum_name   = $db->escape_string(htmlspecialchars_uni($forum['name']));
		$username     = $db->escape_string(htmlspecialchars_uni($post['username']));
		$post_content = $db->escape_string(htmlspecialchars_uni($post['message']));
		
		 $message = "[url={$mybb->settings['bburl']}/member.php?action=profile&uid={$mybb->user['uid']}]{$mybb->user['username']}[/url] has reported a post.\n
			Reason: [quote]".$db->escape_string(htmlspecialchars_uni($mybb->input['reason']))."[/quote]
			Post: [url={$mybb->settings['bburl']}/showthread.php?tid={$post['tid']}&pid={$post['pid']}#pid{$post['pid']}]{$post_subject}[/url]
			Forum: [url={$mybb->settings['bburl']}/forumdisplay.php?fid={$forum['fid']}]{$forum_name}[/url]
			Posted by: [url={$mybb->settings['bburl']}/member.php?action=profile&uid={$post['uid']}]{$username}[/url]\n
			Original Content: [quote]{$post_content}[/quote]";
			
		$posthash = md5($message);
		
		// Building the report thread:
		$reportedthread = array(
		   "fid" => $mybb->settings['reporttoforum_forum'],
		   "subject" => "Reported post by ".$mybb->user['username'],
		   "icon" => "2",
		   "uid" => $mybb->user['uid'],
		   "username" => $mybb->user['username'],
		   "dateline" => TIME_NOW,
		   "lastpost" => TIME_NOW,
		   "lastposter" =>  $mybb->user['username'],
		   "lastposteruid" => $mybb->user['uid'],
		   "views" => 1,
		   "visible" => "1"
		 );    
		    
		 $tid = $db->insert_id($db->insert_query("threads", $reportedthread));
		    
		 // Building the report post:
		 $reportedpost = array(
		   "fid" => $mybb->settings['reporttoforum_forum'],
		   "subject" => "Reported post by ".$mybb->user['username'],
		   "icon" => "2",
		   "uid" => $mybb->user['uid'],
		   "username" => $mybb->user['username'],
		   "dateline" => TIME_NOW,
		   "message" => $message,
		   "ipaddress" => 1,
		   "longipaddress" => 1,
		   "visible" => 1,
		   "posthash" => $posthash
		  );
		    
		  $pid = $db->insert_id($db->insert_query("posts", $reportedpost));

		//Adding the ids to created joints.
		$db->write_query("
		        UPDATE ".TABLE_PREFIX."posts
		        SET tid = '$tid'
		        WHERE dateline=".TIME_NOW." AND subject='Reported post by ".$mybb->user['username']."'");
		        
		$db->write_query("
		        UPDATE ".TABLE_PREFIX."threads
		        SET firstpost = '$pid'
		        WHERE dateline=".TIME_NOW." AND subject='Reported post by ".$mybb->user['username']."'");
		        
		// Update the number of threads and post in the forums.
		$forum_info = $db->fetch_array($db->simple_select("forums", "*", "fid={$mybb->settings['reporttoforum_forum']}"));
		$num_threads = $forum_info['threads']+1;
		$num_posts = $forum_info['posts']+1;
		    
		$db->write_query("
		     UPDATE ".TABLE_PREFIX."forums
		     SET threads='".$num_threads."', posts='".$num_posts."', lastpost='".TIME_NOW."', lastposter='".$mybb->user['username']."', lastposteruid='".$mybb->user['uid']."', lastposttid='$tid', lastpostsubject='Reported post by ".$mybb->user['username']."'
		     WHERE fid={$mybb->settings['reporttoforum_forum']}");
		 
		 // Updates user's post count.
		 $user_posts = $db->fetch_array($db->simple_select("users", "*", "uid={$mybb->user['uid']}")) or die(mysqli_error());
		 $user_posts['postnum'] = $user_posts['postnum']+1;
		 
		 $query = $db->write_query("
		 	UPDATE ".TABLE_PREFIX."users
		    SET postnum={$user_posts['postnum']}
		    WHERE uid={$mybb->user['uid']}");
		
		// If reports are posted on the forum only, then we display a thank you and close the process.
		if($mybb->settings['reporttoforum_only'] == "1")
		{
			global $lang, $settings, $theme, $plugins, $mybbuser, $mybbgroup, $headerinclude;
			global $querytime, $debug, $templatecache, $templatelist, $maintimer, $globaltime, $parsetime;
			
			eval("\$report = \"".$templates->get("report_thanks")."\";");
			$plugins->run_hooks("report_do_report_end");
			output_page($report);
			die();
		}		
	}
}

// This function is called when plugin is deactivated.
function reporttoforum_deactivate() {
	global $db;
	
	$result = $db->query("SELECT gid FROM ".TABLE_PREFIX."settinggroups WHERE name ='reporttoforum' AND title='Report to Forum' LIMIT 1");
	$group = $db->fetch_array($result);
	
	$db->query("DELETE FROM  `".TABLE_PREFIX."settinggroups` WHERE gid='{$group['gid']}' LIMIT 1");
	$db->query("DELETE FROM  `".TABLE_PREFIX."settings` WHERE gid='{$group['gid']}'");
	rebuild_settings();
}
?>